## openssl 3.0.17

=== demos/encode/Makefile ===
#
# To run the demos when linked with a shared library (default):
#
#    LD_LIBRARY_PATH=../.. ./rsa_encode

CFLAGS = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS = -lcrypto

all: ec_encode rsa_encode

%.o: %.c
	$(CC) $(CFLAGS) -c $<

%_encode: %_encode.o

test: ;

clean:
	$(RM) *.o rsa_encode ec_encode

=== demos/mac/Makefile ===
# Quick instruction:
# To build against an OpenSSL built in the source tree, do this:
#
#    make OPENSSL_INCS_LOCATION=-I../../include OPENSSL_LIBS_LOCATION=-L../..
#
# To run the demos when linked with a shared library (default):
#
#    LD_LIBRARY_PATH=../.. ./gmac
#    LD_LIBRARY_PATH=../.. ./poly1305

CFLAGS = $(OPENSSL_INCS_LOCATION) -Wall
LDFLAGS = $(OPENSSL_LIBS_LOCATION) -lssl -lcrypto

all: gmac hmac-sha512 cmac-aes256 poly1305

gmac: gmac.o
hmac-sha512: hmac-sha512.o
cmac-aes256: cmac-aes256.o
poly1305: poly1305.o

gmac hmac-sha512 cmac-aes256 poly1305:
	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS)

clean:
	$(RM) gmac hmac-sha512 cmac-aes256 poly1305 *.o

=== demos/signature/Makefile ===
#
# To run the demos when linked with a shared library (default):
#
#    LD_LIBRARY_PATH=../.. ./EVP_Signature_demo

CFLAGS = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS = -lcrypto

all: EVP_Signature_demo rsa_pss_direct rsa_pss_hash

%.o: %.c
	$(CC) $(CFLAGS) -c $<

EVP_Signature_demo: EVP_Signature_demo.o
rsa_pss_direct: rsa_pss_direct.o
rsa_pss_hash: rsa_pss_hash.o

test: ;

clean:
	$(RM) *.o EVP_Signature_demo rsa_pss_direct rsa_pss_hash

=== debian/changelog ===
openssl (3.0.17-1~deb12u3) bookworm-security; urgency=medium

  * CVE-2025-9230 (Out-of-bounds read & write in RFC 3211 KEK Unwrap)
  * CVE-2025-9232 (Out-of-bounds read in HTTP client no_proxy handling)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 26 Sep 2025 20:59:22 +0200

openssl (3.0.17-1~deb12u2) bookworm; urgency=medium

  * Revert the following upstream changes to avoid crashes in downstream
    software:
    - 7141330fb98ce ("Drop "by store"'s by_store_subject_ex()")
    - 340383f5f49f8 ("Rework the "by store" X509_LOOKUP method to open the given URI early")
    - a468bdb02531e ("Add test_verify tests")
    Closes: #1110254

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 05 Aug 2025 09:09:41 +0200

openssl (3.0.17-1~deb12u1) bookworm; urgency=medium

  * Import 3.0.17

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 13 Jul 2025 14:39:08 +0200

## openssl 3.0.18

=== debian/changelog ===
openssl (3.0.18-1~deb12u2) bookworm-security; urgency=medium

  * CVE-2025-15467 (Stack buffer overflow in CMS AuthEnvelopedData parsing)
  * CVE-2025-68160 (Heap out-of-bounds write in BIO_f_linebuffer on short
    writes)
  * CVE-2025-69418 (Unauthenticated/unencrypted trailing bytes with low-level
    OCB function calls)
  * CVE-2025-69419 (Out of bounds write in PKCS12_get_friendlyname() UTF-8
    conversion)
  * CVE-2025-69420 (Missing ASN1_TYPE validation in TS_RESP_verify_response()
    function)
  * CVE-2025-69421 (NULL Pointer Dereference in PKCS12_item_decrypt_d2i_ex
    function)
  * CVE-2026-22795 (Missing ASN1_TYPE validation in PKCS#12 parsing)
  * CVE-2026-22796 (ASN1_TYPE Type Confusion in the
    PKCS7_digest_from_attributes() function)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 24 Jan 2026 16:01:59 +0100

openssl (3.0.18-1~deb12u1) bookworm; urgency=medium

  * Import 3.0.18

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 01 Nov 2025 12:54:37 +0100

## openssl 3.0.19

=== debian/changelog ===
openssl (3.0.19-1~deb12u1) bookworm; urgency=medium

  * Import 3.0.19

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 22 Feb 2026 18:36:50 +0100

## openssl 3.1.5

=== debian/changelog ===
openssl (3.1.5-1) unstable; urgency=medium

  * Import 3.1.5
    - CVE-2024-0727 (PKCS12 Decoding crashes). (Closes: #1061582).
    - CVE-2023-6237 (Excessive time spent checking invalid RSA public keys)
      (Closes: #1060858).
    - CVE-2023-6129 (POLY1305 MAC implementation corrupts vector registers on
      PowerPC) (Closes: #1060347).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 03 Feb 2024 17:11:24 +0100

openssl (3.1.4-2) unstable; urgency=medium

  * Invoke clean up from the openssl binary as a temporary workaround to avoid
    a crash in libp11/SoftHSM engine (Closes: #1054546).
  * CVE-2023-5678 (Excessive time spent in DH check / generation with large Q
    parameter value) (Closes: #1055473).
  * Upload to unstable.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 25 Nov 2023 21:35:59 +0100

openssl (3.1.4-1) experimental; urgency=medium

  * Import 3.1.4
   - CVE-2023-5363 (Incorrect cipher key and IV length processing).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 24 Oct 2023 21:58:49 +0200

openssl (3.1.3-1) experimental; urgency=medium

  * Import 3.1.3

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 19 Sep 2023 18:57:49 +0200

openssl (3.1.2-1) experimental; urgency=medium

  * Import 3.1.2
   - CVE-2023-2975 (AES-SIV implementation ignores empty associated data
     entries) (Closes: #1041818).
   - CVE-2023-3446 (Excessive time spent checking DH keys and parameters).
     (Closes: #1041817).
   - CVE-2023-3817 (Excessive time spent checking DH q parameter value).
   - Drop bc and m4 from B-D.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 01 Aug 2023 22:51:25 +0200

openssl (3.1.1-1) experimental; urgency=medium

  * Import 3.1.1
    - CVE-2023-0464 (Excessive Resource Usage Verifying X.509 Policy
      Constraints) (Closes: #1034720).
    - CVE-2023-0465 (Invalid certificate policies in leaf certificates are
      silently ignored).
    - CVE-2023-0466 (Certificate policy check not enabled).
    - Alternative fix for CVE-2022-4304 (Timing Oracle in RSA Decryption).
    - CVE-2023-2650 (Possible DoS translating ASN.1 object identifiers).
    - CVE-2023-1255 (Input buffer over-read in AES-XTS implementation on 64 bit ARM).
    - Add new symbol.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 30 May 2023 19:46:00 +0200

openssl (3.1.0-1) experimental; urgency=medium

  * Import 3.1.0
  * Add new symbols.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 06 May 2023 12:11:09 +0200

=== debian/control ===
Source: openssl
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.15.7)
Section: utils
Priority: optional
Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>, Kurt Roeckx <kurt@roeckx.be>, Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/openssl
Vcs-Git: https://salsa.debian.org/debian/openssl.git
Homepage: https://www.openssl.org/
Rules-Requires-Root: no

Package: openssl
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Suggests: ca-certificates
Description: Secure Sockets Layer toolkit - cryptographic utility
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains the general-purpose command line binary /usr/bin/openssl,
 useful for cryptographic operations such as:
  * creating RSA, DH, and DSA key parameters;
  * creating X.509 certificates, CSRs, and CRLs;
  * calculating message digests;
  * encrypting and decrypting with ciphers;
  * testing SSL/TLS clients and servers;
  * handling S/MIME signed or encrypted mail.

Package: libssl3
Section: libs
Architecture: any
Multi-Arch: same
Breaks: openssh-client (<< 1:9.4p1), openssh-server (<< 1:9.4p1), python3-m2crypto (<< 0.38.0-4)
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Sockets Layer toolkit - shared libraries
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It provides the libssl and libcrypto shared libraries.

Package: libcrypto3-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Sockets Layer toolkit - libcrypto udeb
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains a version of the libcrypto shared library for use with the
 Debian Installer. Do not install it on a normal system.

Package: libssl3-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ssl shared library - udeb
 libssl shared library.
 .
 Do not install it on a normal system.

Package: libssl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libssl-doc
Depends: libssl3 (= ${binary:Version}), ${misc:Depends}
Description: Secure Sockets Layer toolkit - development files
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains development libraries, header files, and manpages for libssl
 and libcrypto.

Package: libssl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Secure Sockets Layer toolkit - development documentation
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains manpages and demo files for libssl and libcrypto.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://www.openssl.org/source/ openssl-(3.1.*).tar.gz

## openssl 3.2.0

=== demos/bio/Makefile ===
# Quick instruction:
# To build against an OpenSSL built in the source tree, do this:
#
#    make OPENSSL_INCS_LOCATION=-I../../include OPENSSL_LIBS_LOCATION=-L../..
#
# To run the demos when linked with a shared library (default):
#
#    LD_LIBRARY_PATH=../.. ./server-arg
#    LD_LIBRARY_PATH=../.. ./server-cmod
#    LD_LIBRARY_PATH=../.. ./server-conf
#    LD_LIBRARY_PATH=../.. ./client-arg
#    LD_LIBRARY_PATH=../.. ./client-conf
#    LD_LIBRARY_PATH=../.. ./saccept
#    LD_LIBRARY_PATH=../.. ./sconnect

CFLAGS = $(OPENSSL_INCS_LOCATION)
LDFLAGS = $(OPENSSL_LIBS_LOCATION) -lssl -lcrypto $(EX_LIBS)

all: client-arg client-conf saccept sconnect server-arg server-cmod server-conf

test:

client-arg: client-arg.o
client-conf: client-conf.o
saccept: saccept.o
sconnect: sconnect.o
server-arg: server-arg.o
server-cmod: server-cmod.o
server-conf: server-conf.o

client-arg client-conf saccept sconnect server-arg server-cmod server-conf:
	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS)

clean:
	$(RM) *.o client-arg client-conf saccept sconnect server-arg server-cmod server-conf

=== debian/changelog ===
openssl (3.2.0-2deepin2) unstable; urgency=medium

  * fix CVE-2024-6119.

 -- kongxinglong <kongxinglong@uniontech.com>  Thu, 17 Oct 2024 14:21:08 +0800

openssl (3.2.0-2deepin1) unstable; urgency=medium

  * Update to latest openssl-3.2 branch.
    Update to commit
      462d296ce3822 ("test: add FIPS provider version checks for 3.4 compatibility")
    Fixes: CVE-2024-5535, CVE-2024-4741, CVE-2024-4603, CVE-2024-2511,
           CVE-2024-0727, CVE-2023-6237, CVE-2023-6129

 -- Tianyu Chen <sweetyfish@deepin.org>  Tue, 13 Aug 2024 13:41:34 +0800

openssl (3.2.0-2) experimental; urgency=medium

  * Use generic target for riscv64.
  * Update to latest openssl-3.2 branch.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 14 Dec 2023 21:13:53 +0100

openssl (3.2.0-1) experimental; urgency=medium

  * Import 3.2.0
  * Enable zstd, brotli and for certificate compression.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 26 Nov 2023 13:37:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: openssl
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.15.7)
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.15.7), libzstd-dev, libbrotli-dev
 Section: utils
 Priority: optional
 Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# Modified to be a prototype for debmake by Christoph Lameter <clameter@debian.org>
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs

SHELL=/bin/bash

package=openssl

# For generating the manpages
export VERSION=$(DEB_VERSION_UPSTREAM)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	export CROSS_COMPILE ?= $(DEB_HOST_GNU_TYPE)-
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-zlib no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
	    enable-tfo enable-zstd enable-brotli-dynamic
#OPT_alpha = ev4 ev5
ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
OPTS      = $($(ARCHOPTS))

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITE_FLAGS = HARNESS_VERBOSE=yes
else
	TESTSUITE_FLAGS =
endif

ifeq ($(DEB_HOST_ARCH_CPU), amd64)
	CONFARGS += enable-ec_nistp_64_gcc_128
endif

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		mkdir build_$$opt; \
		cd build_$$opt ; \
		../Configure shared $(CONFARGS) debian-$(DEB_HOST_ARCH)-$$opt; \
		perl configdata.pm -d; \
		cd .. ;\
	done
	mkdir build_static; cd build_static; ../Configure no-shared $(CONFARGS) debian-$(DEB_HOST_ARCH) ;perl configdata.pm -d
	# Debian Perl policy 5.1 (Script Magic)
	mkdir build_shared; cd build_shared; HASHBANGPERL=/usr/bin/perl ../Configure shared $(CONFARGS) debian-$(DEB_HOST_ARCH) ;perl configdata.pm -d

override_dh_auto_build-indep:
	$(MAKE) -C build_shared all

override_dh_auto_build-arch:
	$(MAKE) -C build_static all
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		$(MAKE) -C build_$$opt all; \
	done
	ln -sf apps/openssl.pod crypto/crypto.pod ssl/ssl.pod doc/
	$(MAKE) -C build_shared all

override_dh_auto_test-indep:

override_dh_auto_test-arch:
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	@echo Skipping tests
else
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		$(MAKE) -C build_$$opt test $(TESTSUITE_FLAGS); \
	done
	$(MAKE) -C build_static test $(TESTSUITE_FLAGS)
	$(MAKE) -C build_shared test $(TESTSUITE_FLAGS)
endif

override_dh_auto_clean:
	rm -rf build_static build_shared
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		rm -rf build_$$opt; \
	done
	rm -f doc/openssl.pod doc/crypto.pod doc/ssl.pod
	dh_auto_clean

override_dh_auto_install-indep:
	# Install is only required for the -indep only build, that is if
	# -arch isn't run as well. Otherwise install will fail because
	# usr/lib/ssl/cert is a symlink to a non existing target.
	if [ ! -L debian/tmp/usr/lib/ssl/certs ]; then \
		$(MAKE) -C build_shared install DESTDIR=`pwd`/debian/tmp ;\
		mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl ;\
		mv debian/tmp/usr/include/openssl/opensslconf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/ ;\
		mv debian/tmp/usr/include/openssl/configuration.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/ ;\
	fi

override_dh_auto_install-arch:
	$(MAKE) -C build_shared install DESTDIR=`pwd`/debian/tmp
	# pic static libraries, nobody should need them
	cp -pf build_static/libcrypto.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.a
	cp -pf build_static/libssl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.a
	mkdir -p debian/tmp/etc/ssl
	mv debian/tmp/usr/lib/ssl/{certs,openssl.cnf,private} debian/tmp/etc/ssl/
	ln -s /etc/ssl/{certs,openssl.cnf,private} debian/tmp/usr/lib/ssl/
	ln -s /etc/ssl/certs/ca-certificates.crt debian/tmp/usr/lib/ssl/cert.pem
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.so.* debian/libcrypto3-udeb/usr/lib/
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ossl-modules/*.so debian/libcrypto3-udeb/usr/lib/ossl-modules
	cp -pf debian/tmp/etc/ssl/openssl.cnf debian/libcrypto3-udeb/usr/lib/ssl/openssl.cnf
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.so.* debian/libssl3-udeb/usr/lib/
endif
	cp -auv build_shared/lib*.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	for opt in $(OPTS); \
		do set -xe; \
		mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$$opt; \
		cp -auv build_$$opt/lib*.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$$opt/; \
	done
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl
	mv debian/tmp/usr/include/openssl/opensslconf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/
	mv debian/tmp/usr/include/openssl/configuration.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_fixperms:
	if [ -d debian/openssl/etc/ssl/private ] ; then \
		chmod 700 debian/openssl/etc/ssl/private ; \
	fi
	dh_fixperms -a -X etc/ssl/private

override_dh_perl:
	dh_perl -d

override_dh_makeshlibs:
	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4

override_dh_shlibdeps:
	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3/DEBIAN/shlibs
	dh_shlibdeps -a -L libssl3

## openssl 3.2.1

=== debian/changelog ===
openssl (3.2.1-3ubuntu1) oracular; urgency=medium

  * Merge 3.2.1-3 from Debian unstable (LP: #2067384)
    - Remaining changes:
      + Symlink changelog{,.Debian}.gz and copyright.gz from libssl-dev to
        openssl
      + Use perl:native in the autopkgtest for installability on i386.
      + Disable LTO with which the codebase is generally incompatible
        (LP: #2058017)
      + Add fips-mode detection and adjust defaults when running in fips mode
    - Dropped changes:
      + d/libssl3.postinst: Revert Debian deletion
        - Skip services restart & reboot notification if needrestart is in-use.
        - Bump version check to 1.1.1 (bug opened as LP: #1999139)
        - Use a different priority for libssl1.1/restart-services depending
          on whether a desktop, or server dist-upgrade is being performed.
        - Import libraries/restart-without-asking template as used by above.
      + Add support for building with noudeb build profile which has been
        integrated
      + Patches that forbade TLS < 1.2 @SECLEVEL=2 which is now upstream
        behaviour:
        - skip_tls1.1_seclevel3_tests.patch
        - tests-use-seclevel-1.patch
        - tls1.2-min-seclevel2.patch
      + Revert the provider removal from the default configuration as there's
        no point in carrying the delta (will see if Debian drops the patch)
      + d/p/intel/*: was a backport from upstream changes
      + d/p/CVE-*: was a backport from upstream changes

 -- Adrien Nader <adrien.nader@canonical.com>  Tue, 28 May 2024 14:30:44 +0200

openssl (3.2.1-3) unstable; urgency=medium

  * Upload to unstable.
  * Correct prvious security level in NEWS file (Closes: #1066116).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 04 Apr 2024 22:00:04 +0200

openssl (3.2.1-2) experimental; urgency=medium

  * Disable brotli and enable zlib for certificate compression.
  * Update to latest openssl-3.2 branch.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 22 Feb 2024 21:41:18 +0100

openssl (3.2.1-1.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Mon, 19 Feb 2024 07:33:51 +0000

openssl (3.2.1-1) experimental; urgency=medium

  * Import 3.2.1
   - CVE-2024-0727 (PKCS12 Decoding crashes). (Closes: #1061582).
   - CVE-2023-6237 (Excessive time spent checking invalid RSA public keys)
     (Closes: #1060858).
   - CVE-2023-6129 (POLY1305 MAC implementation corrupts vector registers on
     PowerPC) (Closes: #1060347).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 03 Feb 2024 17:23:00 +0100

openssl (3.0.13-0ubuntu4) oracular; urgency=medium

  * SECURITY UPDATE: Implicit rejection for RSA PKCS#1 (LP: #2054090)
    - debian/patches/openssl-pkcs1-implicit-rejection.patch:
      Return deterministic random output instead of an error in case
      there is a padding error in crypto/cms/cms_env.c,
      crypto/evp/ctrl_params_translate.c, crypto/pkcs7/pk7_doit.c,
      crypto/rsa/rsa_ossl.c, crypto/rsa/rsa_pk1.c,
      crypto/rsa/rsa_pmeth.c, doc/man1/openssl-pkeyutl.pod.in,
      doc/man1/openssl-rsautl.pod.in, doc/man3/EVP_PKEY_CTX_ctrl.pod,
      doc/man3/EVP_PKEY_decrypt.pod,
      doc/man3/RSA_padding_add_PKCS1_type_1.pod,
      doc/man3/RSA_public_encrypt.pod, doc/man7/provider-asym_cipher.pod,
      include/crypto/rsa.h, include/openssl/core_names.h,
      include/openssl/rsa.h,
      providers/implementations/asymciphers/rsa_enc.c and
      test/recipes/30-test_evp_data/evppkey_rsa_common.txt.

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Wed, 15 May 2024 09:54:00 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
 
 SHELL=/bin/bash
 
@@ -30,7 +30,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-zlib no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-brotli-dynamic
+	    enable-tfo enable-zstd enable-zlib
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -145,6 +145,15 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
+override_dh_compress:
+	dh_compress
+	# symlink doc files
+	for p in openssl libssl-dev; do \
+	  for f in changelog.Debian.gz changelog.gz copyright; do \
+	    ln -sf ../libssl3/$$f debian/$$p/usr/share/doc/$$p/$$f; \
+	  done; \
+	done
+
 override_dh_perl:
 	dh_perl -d
 
@@ -152,5 +161,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3/DEBIAN/shlibs
-	dh_shlibdeps -a -L libssl3
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
+	dh_shlibdeps -a -L libssl3t64

## openssl 3.2.2

=== debian/changelog ===
openssl (3.2.2-1ubuntu1) oracular; urgency=medium

  * Merge 3.2.2-1 from Debian unstable
    - Remaining changes:
      + Symlink changelog.Debian.gz and copyright.gz from libssl-dev and
        openssl to the ones in libssl3t64
      + Use perl:native in the autopkgtest for installability on i386.
      + Disable LTO with which the codebase is generally incompatible
        (LP: #2058017)
      + Add fips-mode detection and adjust defaults when running in fips mode
  * The changelog.gz symlink was broken (LP: #1297025)
  * The copyright symlink was broken (LP: #2067672)
  * Default configuration includes two paths:
    - /var/lib/crypto-config/profiles/current/openssl.conf.d
    - /etc/ssl/openssl.conf.d
    First one is to read configuration through the crypto-config framework.
    Second one is for customization by sysadmin.

 -- Adrien Nader <adrien.nader@canonical.com>  Mon, 01 Jul 2024 17:04:32 +0200

openssl (3.2.2-1) unstable; urgency=medium

  * Import 3.2.2
    - CVE-2024-2511 (Unbounded memory growth with session handling in
      TLSv1.3). (Closes: #1068658).
    - CVE-2024-4603 (Excessive time spent checking DSA keys and parameters)
      (Closes: #1071972).
    - CVE-2024-4741 (Use After Free with SSL_free_buffers)
      (Closes: #1072113).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 04 Jun 2024 18:23:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,7 @@
 SHELL=/bin/bash
 
 package=openssl
+library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -148,9 +149,13 @@
 override_dh_compress:
 	dh_compress
 	# symlink doc files
+	# We used to also add symlinks to changelog.gz but pkgstripfiles from
+	# pkgbinarymangler will remove the real changelog.gz file and break all the
+	# symlinks. Ignore changelog, it will end up as wanted.
+	# NB: pkgstripfiles is not done in PPAs
 	for p in openssl libssl-dev; do \
-	  for f in changelog.Debian.gz changelog.gz copyright; do \
-	    ln -sf ../libssl3/$$f debian/$$p/usr/share/doc/$$p/$$f; \
+	  for f in changelog.Debian.gz copyright; do \
+	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
 	  done; \
 	done
 
@@ -161,5 +166,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
-	dh_shlibdeps -a -L libssl3t64
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
+	dh_shlibdeps -a -L $(library_package)

## openssl 3.2.4

=== debian/changelog ===
openssl (3.2.4-0deepin6) unstable; urgency=medium

  * Security update: 13 CVEs
    See: https://github.com/deepin-community/sig-deepin-security/issues/235
    See: https://github.com/deepin-community/sig-deepin-security/issues/232
    - CVE-2025-9230:
      https://github.com/openssl/openssl/commit/b5282d677551afda7d20e9c00e09561b547b2dfd
    - CVE-2025-9231:
      https://github.com/openssl/openssl/commit/cba616c26ac8e7b37de5e77762e505ba5ca51698
    - CVE-2025-9232:
      https://github.com/openssl/openssl/commit/89e790ac431125a4849992858490bed6b225eadf
    - CVE-2025-15467:
      0ddd6b6 Correct handling of AEAD-encrypted CMS with inadmissibly long IV
      b1a995e Some comments to clarify functions usage
      6297ac4 Test for handling of AEAD-encrypted CMS with inadmissibly long IV
    - CVE-2025-15468:
      293b55d ossl_quic_get_cipher_by_char(): Add a NULL guard before dereferencing SSL_CIPHER
    - CVE-2025-66199:
      84f73f7 Check the received uncompressed certificate length to prevent excessive pre-decompression allocation.
    - CVE-2025-68160:
      b21663c Fix heap buffer overflow in BIO_f_linebuffer
    - CVE-2025-69418:
      be9375d Fix OCB AES-NI/HW stream path unauthenticated/unencrypted trailing bytes
    - CVE-2025-69419:
      53b78f2 Check return code of UTF8_putc
    - CVE-2025-69420:
      ea8fc4c Verify ASN1 object's types before attempting to access them as a particular type
    - CVE-2025-69421:
      2c13bf1 PKCS12_item_decrypt_d2i_ex(): Check oct argument for NULL
    - CVE-2026-22795, CVE-2026-22796
      c082649 Ensure ASN1 types are checked before use.

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 28 Jan 2026 16:30:39 +0800

openssl (3.2.4-0deepin5) unstable; urgency=medium

  * bugfix Zhaoxin.GM certificate verify error due to without setting default user id.

 -- luxinyou <luxinyou@uniontech.com>  Mon, 11 Sep 2025 16:00:08 +0800

openssl (3.2.4-0deepin4) unstable; urgency=medium

  * support tlcp for GM-T-0024-2014.

 -- luxinyou <luxinyou@uniontech.com>  Mon, 01 Sep 2025 16:35:08 +0800

openssl (3.2.4-0deepin3) unstable; urgency=medium

  * support architecure for sw64 compile.

 -- luxinyou <luxinyou@uniontech.com>  Fri, 06 Jun 2025 17:18:08 +0800

openssl (3.2.4-0deepin2) unstable; urgency=medium

  * add support Zhaoxin-SM2-3-4 instruction with compiler option no-padlockeng.

 -- luxinyou <luxinyou@uniontech.com>  Thu, 05 Jun 2025 21:48:08 +0800

openssl (3.2.4-0deepin1) unstable; urgency=medium

  * Update to 3.2.4.
    Fixes: CVE-2024-9143, CVE-2024-13176, CVE-2024-12797

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 12 Feb 2025 14:20:08 +0800

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,11 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
 
 SHELL=/bin/bash
 
 package=openssl
-library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -31,7 +30,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-zlib no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-zlib
+	    enable-tfo enable-zstd enable-brotli-dynamic enable-ntls
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -43,7 +42,7 @@
 endif
 
 ifeq ($(DEB_HOST_ARCH_CPU), amd64)
-	CONFARGS += enable-ec_nistp_64_gcc_128
+	CONFARGS += enable-ec_nistp_64_gcc_128 no-padlockeng
 endif
 
 %:
@@ -146,19 +145,6 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
-override_dh_compress:
-	dh_compress
-	# symlink doc files
-	# We used to also add symlinks to changelog.gz but pkgstripfiles from
-	# pkgbinarymangler will remove the real changelog.gz file and break all the
-	# symlinks. Ignore changelog, it will end up as wanted.
-	# NB: pkgstripfiles is not done in PPAs
-	for p in openssl libssl-dev; do \
-	  for f in changelog.Debian.gz copyright; do \
-	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
-	  done; \
-	done
-
 override_dh_perl:
 	dh_perl -d
 
@@ -166,5 +152,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
-	dh_shlibdeps -a -L $(library_package)
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3/DEBIAN/shlibs
+	dh_shlibdeps -a -L libssl3

## openssl 3.3.0

=== debian/changelog ===
openssl (3.3.0-1) experimental; urgency=medium

  * Import 3.3.0.
    - CVE-2024-2511 (Unbounded memory growth with session handling in TLSv1.3)
      (Closes: #1068658).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 11 Apr 2024 21:49:45 +0200

openssl (3.3.0~beta1-1) experimental; urgency=medium

  * Import 3.3.0-beta1.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 05 Apr 2024 23:09:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: openssl
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.15.7), libzstd-dev, libbrotli-dev
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
 Section: utils
 Priority: optional
 Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
@@ -29,11 +29,13 @@
   * testing SSL/TLS clients and servers;
   * handling S/MIME signed or encrypted mail.
 
-Package: libssl3
+Package: libssl3t64
+Provides: ${t64:Provides}
+Replaces: libssl3
 Section: libs
 Architecture: any
 Multi-Arch: same
-Breaks: openssh-client (<< 1:9.4p1), openssh-server (<< 1:9.4p1), python3-m2crypto (<< 0.38.0-4)
+Breaks: libssl3 (<< ${source:Version}), openssh-client (<< 1:9.4p1), openssh-server (<< 1:9.4p1), python3-m2crypto (<< 0.38.0-4)
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Secure Sockets Layer toolkit - shared libraries
@@ -73,7 +75,7 @@
 Architecture: any
 Multi-Arch: same
 Suggests: libssl-doc
-Depends: libssl3 (= ${binary:Version}), ${misc:Depends}
+Depends: libssl3t64 (= ${binary:Version}), ${misc:Depends}
 Description: Secure Sockets Layer toolkit - development files
  This package is part of the OpenSSL project's implementation of the SSL
  and TLS cryptographic protocols for secure communication over the

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-zlib no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-brotli-dynamic enable-ntls
+	    enable-tfo enable-zstd enable-zlib
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -42,7 +42,7 @@
 endif
 
 ifeq ($(DEB_HOST_ARCH_CPU), amd64)
-	CONFARGS += enable-ec_nistp_64_gcc_128 no-padlockeng
+	CONFARGS += enable-ec_nistp_64_gcc_128
 endif
 
 %:
@@ -152,5 +152,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3/DEBIAN/shlibs
-	dh_shlibdeps -a -L libssl3
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
+	dh_shlibdeps -a -L libssl3t64

## openssl 3.3.1

=== demos/guide/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./tls-client-block www.example.com 443

TESTS = tls-client-block \
        quic-client-block \
        quic-multi-stream \
        tls-client-non-block \
        quic-client-non-block

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto -lssl

all: $(TESTS)

tls-client-block: tls-client-block.o
quic-client-block: quic-client-block.o
quic-multi-stream: quic-multi-stream.o
tls-client-non-block: tls-client-non-block.o
quic-client-non-block: quic-client-non-block.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) $(TESTS) *.o

.PHONY: test
test: all
	@echo "\nTLS and QUIC tests:"
	@echo "skipped"

=== debian/changelog ===
openssl (3.3.1-2ubuntu2.1) oracular-security; urgency=medium

  * SECURITY UPDATE: Low-level invalid GF(2^m) parameters lead to OOB
    memory access
    - debian/patches/CVE-2024-9143.patch: harden BN_GF2m_poly2arr against
      misuse in crypto/bn/bn_gf2m.c, test/ec_internal_test.c.
    - CVE-2024-9143
  * SECURITY UPDATE: A timing side-channel which could potentially allow
    recovering the private key exists in the ECDSA signature computation
    - debian/patches/CVE-2024-13176.patch: Fix timing side-channel in
      ECDSA signature computation in crypto/bn/bn_exp.c,
      crypto/ec/ec_lib.c, include/crypto/bn.h.
    - CVE-2024-13176
  * SECURITY UPDATE: RFC7250 handshakes with unauthenticated servers don't
    abort as expected
    - debian/patches/CVE-2024-12797-1.patch: with SSL_VERIFY_PEER client
      RPK should abort on X509 error in ssl/statem/statem_clnt.c,
      test/rpktest.c.
    - debian/patches/CVE-2024-12797-2.patch: use ERR marks also when
      verifying server X.509 certs in ssl/statem/statem_clnt.c,
      test/rpktest.c.
    - CVE-2024-12797
  * debian/patches/issue26466.patch: restore correct registers in aarch64
    AES-CTR code in crypto/aes/asm/aesv8-armx.pl.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 05 Feb 2025 07:56:37 -0500

openssl (3.3.1-2ubuntu2) oracular; urgency=medium

  * SECURITY UPDATE: Possible denial of service in X.509 name checks
    - debian/patches/CVE-2024-6119.patch: avoid type errors in EAI-related
      name check logic in crypto/x509/v3_utl.c, test/*.
    - CVE-2024-6119
  * Add Ubuntu-specific defines to help FIPS certification (LP: #2073991)
    - UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
    - UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE

 -- Adrien Nader <adrien.nader@canonical.com>  Wed, 11 Sep 2024 16:09:42 +0200

openssl (3.3.1-2ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable (LP: #2044795). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - patch: crypto: Add kernel FIPS mode detection
    - patch: crypto: Automatically use the FIPS provider...
    - patch: apps/speed: Omit unavailable algorithms in FIPS mode
    - patch: apps: pass -propquery arg to the libctx DRBG fetches
    - patch: test: Ensure encoding runs with the correct context...
    - SECURITY UPDATE: crash or memory disclosure via SSL_select_next_proto
      - debian/patches/CVE-2024-5535*.patch: validate provided client list in
        ssl/ssl_lib.c.
      - CVE-2024-5535

 -- Simon Chopin <schopin@ubuntu.com>  Mon, 12 Aug 2024 13:49:56 +0200

openssl (3.3.1-2) unstable; urgency=medium

  * Upload to unstable.
  * Add support for hurd-amd64, patch by Samuel Thibault (Closes: #1076324).
  * Use the static archive from the shared build.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 03 Aug 2024 16:17:50 +0200

openssl (3.3.1-1) experimental; urgency=medium

  * Import 3.3.1.
    - CVE-2024-4603 (Excessive time spent checking DSA keys and parameters)
      (Closes: #1071972).
    - CVE-2024-4741 (Use After Free with SSL_free_buffers)
      (Closes: #1072113).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 04 Jun 2024 18:37:30 +0200

openssl (3.2.2-1ubuntu3) oracular; urgency=medium

  * Added extra commits to previous upload to fix FTBFS in quic tests
    - debian/patches/CVE-2024-5535-2.patch: more correctly handle a
      selected_len of 0 when processing NPN in ssl/statem/extensions_clnt.c.
    - debian/patches/CVE-2024-5535-3.patch: use correctly formatted ALPN
      data in tserver in ssl/quic/quic_tserver.c.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 02 Aug 2024 07:41:40 -0400

openssl (3.2.2-1ubuntu2) oracular; urgency=medium

  * SECURITY UPDATE: crash or memory disclosure via SSL_select_next_proto
    - debian/patches/CVE-2024-5535.patch: validate provided client list in
      ssl/ssl_lib.c.
    - CVE-2024-5535

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 31 Jul 2024 13:16:18 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
 Section: utils
 Priority: optional
-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
 Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>, Kurt Roeckx <kurt@roeckx.be>, Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/openssl

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,12 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
 
 SHELL=/bin/bash
 
 package=openssl
+library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -29,7 +30,7 @@
 	MAKEFLAGS += -j$(NUMJOBS)
 endif
 
-CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-zlib no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
+CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
 	    enable-tfo enable-zstd enable-zlib
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
@@ -58,7 +59,6 @@
 		perl configdata.pm -d; \
 		cd .. ;\
 	done
-	mkdir build_static; cd build_static; ../Configure no-shared $(CONFARGS) debian-$(DEB_HOST_ARCH) ;perl configdata.pm -d
 	# Debian Perl policy 5.1 (Script Magic)
 	mkdir build_shared; cd build_shared; HASHBANGPERL=/usr/bin/perl ../Configure shared $(CONFARGS) debian-$(DEB_HOST_ARCH) ;perl configdata.pm -d
 
@@ -66,7 +66,6 @@
 	$(MAKE) -C build_shared all
 
 override_dh_auto_build-arch:
-	$(MAKE) -C build_static all
 	test -z "$(OPTS)" || for opt in $(OPTS); \
 	do \
 		set -xe; \
@@ -86,12 +85,11 @@
 		set -xe; \
 		$(MAKE) -C build_$$opt test $(TESTSUITE_FLAGS); \
 	done
-	$(MAKE) -C build_static test $(TESTSUITE_FLAGS)
 	$(MAKE) -C build_shared test $(TESTSUITE_FLAGS)
 endif
 
 override_dh_auto_clean:
-	rm -rf build_static build_shared
+	rm -rf build_shared
 	test -z "$(OPTS)" || for opt in $(OPTS); \
 	do \
 		set -xe; \
@@ -114,8 +112,8 @@
 override_dh_auto_install-arch:
 	$(MAKE) -C build_shared install DESTDIR=`pwd`/debian/tmp
 	# pic static libraries, nobody should need them
-	cp -pf build_static/libcrypto.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.a
-	cp -pf build_static/libssl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.a
+	cp -pf build_shared/libcrypto.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.a
+	cp -pf build_shared/libssl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.a
 	mkdir -p debian/tmp/etc/ssl
 	mv debian/tmp/usr/lib/ssl/{certs,openssl.cnf,private} debian/tmp/etc/ssl/
 	ln -s /etc/ssl/{certs,openssl.cnf,private} debian/tmp/usr/lib/ssl/
@@ -145,6 +143,19 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
+override_dh_compress:
+	dh_compress
+	# symlink doc files
+	# We used to also add symlinks to changelog.gz but pkgstripfiles from
+	# pkgbinarymangler will remove the real changelog.gz file and break all the
+	# symlinks. Ignore changelog, it will end up as wanted.
+	# NB: pkgstripfiles is not done in PPAs
+	for p in openssl libssl-dev; do \
+	  for f in changelog.Debian.gz copyright; do \
+	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
+	  done; \
+	done
+
 override_dh_perl:
 	dh_perl -d
 
@@ -152,5 +163,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
-	dh_shlibdeps -a -L libssl3t64
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
+	dh_shlibdeps -a -L $(library_package)

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://www.openssl.org/source/ openssl-(3.3.*).tar.gz

## openssl 3.3.2

=== debian/changelog ===
openssl (3.3.2-2) unstable; urgency=medium

  - CVE-2024-9143 (Low-level invalid GF(2^m) parameters lead to OOB memory
    access) (Closes: #1085378).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 27 Oct 2024 15:19:50 +0100

openssl (3.3.2-1) unstable; urgency=medium

  * Import 3.3.2.
    - CVE-2024-6119 (Possible denial of service in X.509 name checks).
    - CVE-2024-5535 (SSL_select_next_proto buffer overread)
      (Closes: #1074487).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 03 Sep 2024 21:43:24 +0200

openssl (3.3.1-7) unstable; urgency=medium

  * Make libssl3t64 depend on openssl-provider-legacy (See further development
    in #965041).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Mon, 19 Aug 2024 23:38:33 +0200

openssl (3.3.1-6) unstable; urgency=medium

  [ Sebastian Andrzej Siewior ]
  * Enable ec_nistp_64_gcc_128 on arm64, ppc64el, riscv64. Initially suggested
    by Joel Stanley.
  * Add a "prefix" for pkg-config and cmake exporter
    (Closes: #1078509, #1078020).
  * Add Breaks/ Replaces to the legacy provider also against libssl3
    (Closes: #1078551).
  * Upload to unstable.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entries 0.9.8a-7, 0.9.8a-6, 0.9.8a-4.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 13 Aug 2024 21:39:36 +0200

openssl (3.3.1-5) experimental; urgency=medium

  * Split the legacy provider into its own package (Closes: #965041).
  * Add the FIPS provider (Closes: #1050210).
  * Reintroduce the provider section back in the default openssl.cnf. This is
    was to keep compatibility with the openssl 1.1 series. Adding makes it
    easier to add/ enable provides such as fips.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 04 Aug 2024 23:22:06 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,11 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
 
 SHELL=/bin/bash
 
 package=openssl
-library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -31,7 +30,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-zlib
+	    enable-tfo enable-zstd enable-zlib enable-fips
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -42,7 +41,7 @@
 	TESTSUITE_FLAGS =
 endif
 
-ifeq ($(DEB_HOST_ARCH_CPU), amd64)
+ifneq ($(filter amd64 arm64 ppc64el riscv64,$(DEB_HOST_ARCH_CPU)),)
 	CONFARGS += enable-ec_nistp_64_gcc_128
 endif
 
@@ -143,19 +142,6 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
-override_dh_compress:
-	dh_compress
-	# symlink doc files
-	# We used to also add symlinks to changelog.gz but pkgstripfiles from
-	# pkgbinarymangler will remove the real changelog.gz file and break all the
-	# symlinks. Ignore changelog, it will end up as wanted.
-	# NB: pkgstripfiles is not done in PPAs
-	for p in openssl libssl-dev; do \
-	  for f in changelog.Debian.gz copyright; do \
-	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
-	  done; \
-	done
-
 override_dh_perl:
 	dh_perl -d
 
@@ -163,5 +149,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
-	dh_shlibdeps -a -L $(library_package)
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
+	dh_shlibdeps -a -L libssl3t64

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://openssl-library.org/source/ https://github.com/openssl/openssl/releases/download/.*openssl-(3.3.*).tar.gz

## openssl 3.4.0~~beta1

=== debian/changelog ===
openssl (3.4.0~~beta1-1) experimental; urgency=medium

  * Import 3.4.0-beta1

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Mon, 07 Oct 2024 23:03:28 +0200
